// @see http://www.nicovideo.jp/watch/sm23871006
// put Beam_lv1_Light.mqo in same folder/directory
#define timeLength 0.25
#define RADIUS 0.03125

uniform float time;
varying float alpha;

void AllFunc()
{
	int index = int(gl_Vertex.x + gl_Vertex.y) + 1;

	float t = 1.0 - time/(timeLength*float(index));
	float w = 0.1;
	w *= 5.0+(1.0-pow(1.0-t, 16.0))*2.0*pow(8.0, float(index));
	w *= 0.25;
	w *= RADIUS;

	vec4 pos = vec4(0.0, 0.0, 0.0, 0.0);
	pos.w    = gl_Vertex.w;
	gl_Position  = gl_ModelViewProjectionMatrix * pos;

	gl_PointSize = gl_Point.size * w;

	//alpha
	alpha = 1.0 - pow(t, 5.0-float(index));
}

void main(void) {
	AllFunc();
}